import jp.starlogic.dto.Dto;
import mx.remoting.Service;
import mx.remoting.PendingCall;
import mx.rpc.RelayResponder;
import mx.rpc.FaultEvent;
import mx.rpc.ResultEvent;
import jp.starlogic.commons.Consts;
import org.as2lib.env.log.Logger;
import org.as2lib.env.log.LogManager;


class jp.starlogic.remoting.ServerRemote{
	private var logger : Logger = LogManager.getLogger ("jp.starlogic.remoting.ServerRemote");
	var __root;
	static var gatewayUrl:String = Consts.GATEWAY_URL;
	static var serviceName:String = Consts.SERVICE_NAME;
	static var service:Service = new Service(
                               	gatewayUrl,
                               	null,
                               	serviceName,
                               	null,
                               	null);
	
	function ServerRemote(root){
		logger.debug("#ServerRemote(root) root = " + root );
		__root = root;

	}
	
	function remote(arg:Dto){
		logger.debug("#remote(arg) arg = " + arg);
		__root.outLabel.text = Consts.FIND_FINDING;
   		var pc:PendingCall = service.doAction(arg);
   		pc.responder = new RelayResponder(this, "doAction_Result", "doAction_Fault");
	}


	public function doAction_Result(re:ResultEvent):Void {
		logger.debug("#doAction_Result(re) re = " + re);
    	var plusDto = re.result;
		if(re.result.length == 0){
			__root.outLabel.text = Consts.FIND_NORETURN;
		}else{
			__root.outLabel.text = Consts.FIND_FINDEND;
		}
    	__root.resultGrid.dataProvider = re.result;
	}

	public function doAction_Fault(fa:FaultEvent):Void {
		logger.debug("#doAction_Fault(fa) fa = " + fa);
    	logger.debug("faultstring = " + fa.fault.faultstring);
    	logger.debug("faultcode = " + fa.fault.faultcode);
    	logger.debug("type = " + fa.fault.type);
    	logger.debug("detail = " + fa.fault.detail);
	}	
}